/*
 * Thermostat.hpp
 *
 *  Created on: Aug 18, 2010
 *      Author: crueger
 */

#ifndef THERMOSTAT_HPP_
#define THERMOSTAT_HPP_

class config;

#include <string>
#include <set>
#include <vector>
#include <list>
#include "AtomSet.hpp"

class ThermoStatContainer;

class Thermostat
{
public:
  Thermostat();
  virtual ~Thermostat();

  // cannot template this, because we need virtual functions
  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms)=0;
  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms)=0;
  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms)=0;

  virtual std::string name()=0;

  virtual std::string writeParams()=0;
  void addToContainer(ThermoStatContainer *);
protected:
  ThermoStatContainer &getContainer();
private:
  ThermoStatContainer* container;
};

template <class Thermostat>
struct ThermostatTraits;

template <>
struct ThermostatTraits<Thermostat>{
  virtual Thermostat *make(class ConfigFileBuffer * const fb)=0;
  virtual std::string getName();
  static const char* name;
};

#endif /* THERMOSTAT_HPP_ */
